﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _1AlgPozycyjneReprezentacjeliczb
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        private String zamiana10naInnyIteracja(int l, byte p)
        {
            String wynik = "";
            while (l > 0)
            {
                if (l % p > 9)
                    switch (l % p)
                    {
                        case 10: wynik = "A" + wynik; break;
                        case 11: wynik = "B" + wynik; break;
                        case 12: wynik = "C" + wynik; break;
                        case 13: wynik = "D" + wynik; break;
                        case 14: wynik = "E" + wynik; break;

                    }
                else wynik = (l % p).ToString() + wynik;
                l = l / p;
            }
            return wynik;
        }
        private String zamiana10naInnyRekurencja(int l, byte p)
        {
            String wynik = "";
            if (l > 0)
            {
                wynik += zamiana10naInnyRekurencja(l / p, p);
                if (l % p > 9)
                    switch (l % p)
                    {
                        case 10: wynik += "A"; break;
                        case 11: wynik += "B"; break;
                        case 12: wynik += "C"; break;
                        case 13: wynik += "D"; break;
                        case 14: wynik += "E"; break;
                        case 15: wynik += "F"; break;
                    }
                else wynik += (l % p).ToString();
            }
            return wynik;
        }

        private byte Wartosc(Char znak)
        {
            byte a = 0;
            switch (znak)
            {
                case 'A': a = 10; break;
                case 'B': a = 11; break;
                case 'C': a = 12; break;
                case 'D': a = 13; break;
                case 'E': a = 14; break;
                case 'F': a = 15; break;
                default: a = Convert.ToByte(znak - '0'); break;
            }
            return a;
        }
        //s- to łańcuch znaków podanej liczby
        //p- podstawa systemu
        private long DowolnyNaDziesietny(String s, byte p)
        {
            long wynik = 0;
            int i = 0;
            while (i < s.Length - 1)
            {
                wynik = (wynik + Wartosc(s[i])) * p;
                i++;
            }
            wynik += Wartosc(s[i]);
            return wynik;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //ustaw pierwszy indeks w combobox na aktywny
            comboBox1.SelectedIndex = 0;
            comboBox2.SelectedIndex = 0;
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            //zabezpiecz przed znakami nienumerycznymi
            if (e.KeyChar == 8) return;//wyskocz jak BackSpace
            if (e.KeyChar < '0' || e.KeyChar > '9') e.Handled = true;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1)
            {
                MessageBox.Show("Nie podano liczby!", 
                                "Komunikat",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Warning);
                return;
            }
            int l = Convert.ToUInt16(textBox1.Text);
            byte p = Convert.ToByte(comboBox1.Text);
            if (l > 0) label3.Text = zamiana10naInnyRekurencja(l, p);
            else label3.Text = "0";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length < 1)
            {
                MessageBox.Show("Nie podano liczby!",
                                "Komunikat",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Warning);
                return;
            }
            int l = Convert.ToUInt16(textBox1.Text);
            byte p = Convert.ToByte(comboBox1.Text);
            if (l > 0) label3.Text = zamiana10naInnyIteracja(l, p);
            else label3.Text = "0";
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //zamień z dwolonego na dziesietny
            if (textBox2.Text.Length < 1)
            {
                MessageBox.Show("Nie podano liczby!", 
                                "Komunikat",
                                MessageBoxButtons.OK,
                                MessageBoxIcon.Warning);
                return;
            }
            byte p = Convert.ToByte(comboBox2.Text);
            label4.Text = DowolnyNaDziesietny(textBox2.Text, p).ToString();
        }
    }
}
