﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _1AlgPozycyjneReprezentacjeliczb
{
    internal class SystemyLiczbowe
    {
        //l to liczba dziesietna,
        //p to podstawa systemy na ktory jest przeprowadzana zamiana
        public static String zamiana10naInnyRekurencja(int l,byte p)
        {
            String wynik="";
            if (l > 0)
            {
                wynik+=zamiana10naInnyRekurencja(l / p, p);
                if (l % p > 9)
                    switch (l % p)
                    {
                        case 10: wynik += "A"; break;
                        case 11: wynik += "B"; break;
                        case 12: wynik += "C"; break;
                        case 13: wynik += "D"; break;
                        case 14: wynik += "E"; break;
                        case 15: wynik += "F"; break;
                    }
                else wynik+= (l % p).ToString();
            }  
            return wynik;
        }
        public static String zamiana10naInnyIteracja(int l, byte p)
        {
            String wynik = "";
            while (l > 0)
                {
                if (l % p > 9)
                    switch (l%p){
                      case 10: wynik = "A" + wynik;break;
                      case 11: wynik = "B" + wynik; break;
                      case 12: wynik = "C" + wynik; break;
                      case 13: wynik = "D" + wynik; break;
                      case 14: wynik = "E" + wynik; break;

                    }
                    else wynik = (l % p).ToString() + wynik;
                    l = l / p;
                }
            return wynik;
        }
        private static byte Wartosc(Char znak)
        {
            byte a = 0;
            switch (znak)
            {
                case 'A': a = 10; break;
                case 'B': a = 11; break;
                case 'C': a = 12; break;
                case 'D': a = 13; break;
                case 'E': a = 14; break;
                case 'F': a = 15; break;
                default: a = Convert.ToByte(znak-'0'); break;
            }
            return a;
        }
        //s- to łańcuch znaków podanej liczby
        //p- podstawa systemu
        public static long DowolnyNaDziesietny(String s,byte p)
        {
            long wynik = 0;
            int i=0;
            while(i< s.Length-1)
            {
                wynik = (wynik + Wartosc(s[i])) * p;
                i++;
            }
            wynik+= Wartosc(s[i]);
            return wynik;
        }
    }
}
